DROP VIEW user_perm_snapshot_v;

CREATE VIEW user_perm_snapshot_v AS 
  SELECT DISTINCT appl.qid appl_qid,
        ds.name appl_name,
        perm.unique_permission_id perm_qid,
        perm.name perm_name,
        perm.type,
        usr.unique_user_id user_qid,
        usr.dn user_dn,
        usr.last_name user_last_name,
        usr.first_name user_first_name,
        usr.idm_tree_name user_idm_tree_name,
        snap.id snap_id,
        snap.timestamp snap_timestamp
       FROM spermission perm
         LEFT JOIN application appl ON perm.application = appl.id
         LEFT JOIN spermission pcoll ON perm.collected_entity = pcoll.id
         LEFT JOIN saccount_permission ap ON pcoll.id = ap.spermission
         LEFT JOIN saccount acoll ON ap.saccount = acoll.id
         LEFT JOIN saccount_user au ON acoll.id = au.saccount
         LEFT JOIN saccount acct ON acoll.id = acct.collected_entity
         LEFT JOIN suser ucoll ON au.suser = ucoll.id
         LEFT JOIN suser usr ON ucoll.id = usr.collected_entity
         LEFT JOIN data_source ds ON appl.id = ds.id
         LEFT JOIN snapshot_sversions ap_snap_sv ON ap.sversion = ap_snap_sv.sversions
         LEFT JOIN snapshot_sversions au_snap_sv ON au.sversion = au_snap_sv.sversions
         JOIN snapshot snap ON ap_snap_sv.snapshot = snap.id AND au_snap_sv.snapshot = snap.id;

GRANT SELECT ON igops.user_perm_snapshot_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM user_perm_snapshot_v for igops.user_perm_snapshot_v;